/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Pegawai;
import com.portofolio.entity.vo.PegawaiId;

@Lazy
@Repository

public interface PegawaiDao extends CrudRepository<Pegawai, PegawaiId> {

	
	@Query(QListAll + " and lower(model.namaLengkap) like %:criteria% and model.kdStatusPegawai=:kdStatusPegawai")
	Page<Map<String, Object>> findAllListPegawaiUser(@Param("kdProfile") Integer kdProfile, @Param("kdStatusPegawai") Integer kdStatusPegawai,@Param("criteria") String criteria,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	
	@Query(QListAll+" and model.kdStatusPegawai=:kdStatusPegawai")
	Page<Map<String, Object>> findAllListPegawaiUser(@Param("kdProfile") Integer kdProfile, @Param("kdStatusPegawai") Integer kdStatusPegawai,@Param("statusEnabled") boolean statusEnabled,Pageable page);
	
    
    @Query(QListAll + " and model.id.kdPegawai = :kdPegawai")
    Map<String, Object> findByKdPegawai(@Param("kdProfile") Integer kdProfile, @Param("kdPegawai") String kdPegawai,@Param("statusEnabled") boolean statusEnabled);
       

	String QListAll = " select new map"
			+ " (model.id.kdPegawai as kdPegawai"
			+ " ,model.id.kdProfile as kdProfile" 
			+ " ,model.nIKIntern as NIK"
			+ " ,model.version as version"
			+ " ,model.namaLengkap as namaLengkap" 

//			+ "  CONCAT(alamat.alamatLengkap,' RT ',alamat.rTRW,',Desa/Kel ',desaKelurahan.namaDesaKelurahan,',Kecamatan ',kecamatan.namaKecamatan,',',kotaKabupaten.namaKotaKabupaten,',',propinsi.namaPropinsi,',',alamat.kodePos ) as concatAlamatLengkap"
//			+ ", alamat.id.kdAlamat as kdAlamat"
//			+ ", alamat.id.kdProfile as kdProfile " 
//			+ ", alamat.kdJenisAlamat as kdJenisAlamat "
//			+ ", alamat.alamatLengkap as alamatLengkap "
//			+ ", alamat.kdDesaKelurahan as kdDesaKelurahan " 
//			+ ", alamat.rTRW as rTRW " 
//			+ ", alamat.kdKecamatan as kdKecamatan " 
//			+ ", alamat.kdKotaKabupaten as kdKotaKabupaten " 
//			+ ", alamat.kdPropinsi as kdPropinsi " 
//			+ ", alamat.kodePos as kodePos " 
//			+ ", alamat.kdNegara as kdNegara "
//			+ ", alamat.fixedPhone1 as fixedPhone1 " 
//			+ ", alamat.mobilePhone1 as mobilePhone1 " 
//			+ ", alamat.faksimile1 as faksimile1 " 
//			+ ", alamat.alamatEmail as alamatEmail " 
//			+ ", alamat.website as website "
//			+ ", alamat.blackBerry as blackBerry " 
//			+ ", alamat.enumAlamat as enumAlamat " 
//			+ ", alamat.whatsApp as whatsApp "
//			+ ", alamat.yahooMessenger as yahooMessenger "
//			+ ", alamat.keteranganLainnya as keteranganLainnya " 
//			+ ", alamat.tglDaftar as tglDaftar "
//			+ ", alamat.statusEnabled as statusEnabled " 
//			+ ", alamat.noRec as noRec "
//			+ ", alamat.garisLintangLatitude as garisLintangLatitude "
//			+ ", alamat.garisBujurLongitude as garisBujurLongitude " 
//			+ ", negara.namaNegara as namaNegara" 
//			+ ", negara.kdNegara as kdNegara" 
//			+ ", propinsi.namaPropinsi as namaPropinsi "
//			+ ", kotaKabupaten.namaKotaKabupaten as namaKotaKabupaten" 
//			+ ", kecamatan.namaKecamatan as namaKecamatan"
//			+ ", desaKelurahan.namaDesaKelurahan as namaDesaKelurahan"
//			+ ", jenisAlamat.namaJenisAlamat as namaJenisAlamat "
			
			+ ", jabatan.namaJabatan as namaJabatan "
			+ ", jabatan.id.kdJabatan as kdJabatan "
			
			+ ", ruanganKerja.namaRuangan  as namaRuanganKerja"
			+ ", ruanganKerja.id.kdRuangan  as kdRuanganKerja"

			+ ", jenisKelamin.namaJenisKelamin as namaJenisKelamin  "
			+ ", jenisKelamin.id.kdJenisKelamin as kdJenisKelamin  "
			
			+ ", jenisPegawai.namaJenisPegawai as namaJenisPegawai "
			+ ", jenisPegawai.id.kdJenisPegawai as kdJenisPegawai "
			
			+ ", departemen.namaDepartemen as namaDepartemen "
			+ ", departemen.id.kdDepartemen as kdDepartemen "
			
			+ ", agama.namaAgama as namaAgama "
			+ ", agama.id.kdAgama as kdAgama "
			
			+ ", golonganPegawai.id.kdGolonganPegawai as kdGolonganPegawai "
			+ ", golonganPegawai.namaGolonganPegawai as namaGolonganPegawai "
			
			+ ", golonganDarah.id.kdGolonganDarah as kdGolonganDarah "
			+ ", golonganDarah.namaGolonganDarah as namaGolonganDarah "
			
			+ ", kategoryPegawai.id.kdKategoryPegawai as kdKategoryPegawai "
			+ ", kategoryPegawai.namaKategoryPegawai as namaKategoryPegawai "
			
			+ ", negaraAsal.kdNegara as kdNegaraAsal "
			+ ", negaraAsal.namaNegara as namaNegaraAsal "
			
			+ ", pangkat.id.kdPangkat as kdPangkat "
			+ ", pangkat.namaPangkat as namaPangkat "
			
			+ ", pegawaiHead.id.kdPegawai as kdPegawaiHead "
			+ ", pegawaiHead.namaLengkap as namaLengkapPegawaiHead "
			
			+ ", pendidikanTerakhir.id.kdPendidikan as kdPendidikanTerakhir "
			+ ", pendidikanTerakhir.namaPendidikan as namaPendidikanTerakhir "
			
			+ ", statusPerkawinan.id.kdStatus as kdStatusPerkawinan "
			+ ", statusPerkawinan.namaStatus as namaStatusPerkawinan "
			
			+ ", suku.id.kdSuku as kdSuku "
			+ ", suku.namaSuku as namaSuku "
			
			+ ", title.id.kdTitle as kdTitle "
			+ ", title.namaTitle as namaTitle "
			
			+ ", typePegawai.id.kdTypePegawai as kdTypePegawai "
			+ ", typePegawai.namaTypePegawai as namaTypePegawai "
			+ ") " 
			
			+ " from Pegawai model " 
			+ " left join model.jenisKelamin jenisKelamin "
			+ " left join model.jenisPegawai jenisPegawai " 
			+ " left join model.jabatan jabatan "
			+ " left join model.agama agama "
			+ " left join model.departemen departemen "
			+ " left join model.golonganPegawai golonganPegawai "
			+ " left join model.golonganDarah golonganDarah "
			+ " left join model.kategoryPegawai kategoryPegawai "
			+ " left join model.negaraAsal negaraAsal "
			+ " left join model.pangkat pangkat "
			+ " left join model.pegawaiHead pegawaiHead "
			+ " left join model.pendidikanTerakhir pendidikanTerakhir "
			+ " left join model.statusPerkawinan statusPerkawinan "
			+ " left join model.suku suku "
			+ " left join model.title title "
			+ " left join model.typePegawai typePegawai "
			+ " left join model.ruanganKerja ruanganKerja "
			+ " left join Alamat alamat on alamat.kdPegawai= model.id.kdPegawai and alamat.id.kdProfile=model.id.kdProfile "
			+ " left join alamat.negara negara " 
			+ " left join alamat.propinsi propinsi "
			+ " left join alamat.kotaKabupaten kotaKabupaten " 
			+ " left join alamat.kecamatan kecamatan "
			+ " left join alamat.desaKelurahan desaKelurahan " 
			+ " left join alamat.jenisAlamat jenisAlamat "
			+ " where model.id.kdProfile =:kdProfile "
			+ " and model.statusEnabled =:statusEnabled "
			+ " and model.tglMasuk is not null ";

}
